/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
	"fmt"
)

// ContactExcludeRelation the model 'ContactExcludeRelation'
type ContactExcludeRelation string

// List of ContactExcludeRelation
const (
	ContactExcludeRelationAll ContactExcludeRelation = "all"
	ContactExcludeRelationSegments ContactExcludeRelation = "Segments"
	ContactExcludeRelationComChannels ContactExcludeRelation = "ComChannels"
	ContactExcludeRelationPlatformComChannels ContactExcludeRelation = "PlatformComChannels"
	ContactExcludeRelationCoupons ContactExcludeRelation = "Coupons"
)

// All allowed values of ContactExcludeRelation enum
var AllowedContactExcludeRelationEnumValues = []ContactExcludeRelation{
	"all",
	"Segments",
	"ComChannels",
	"PlatformComChannels",
	"Coupons",
}

func (v *ContactExcludeRelation) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := ContactExcludeRelation(value)
	for _, existing := range AllowedContactExcludeRelationEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid ContactExcludeRelation", value)
}

// NewContactExcludeRelationFromValue returns a pointer to a valid ContactExcludeRelation
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewContactExcludeRelationFromValue(v string) (*ContactExcludeRelation, error) {
	ev := ContactExcludeRelation(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for ContactExcludeRelation: valid values are %v", v, AllowedContactExcludeRelationEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v ContactExcludeRelation) IsValid() bool {
	for _, existing := range AllowedContactExcludeRelationEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to ContactExcludeRelation value
func (v ContactExcludeRelation) Ptr() *ContactExcludeRelation {
	return &v
}

type NullableContactExcludeRelation struct {
	value *ContactExcludeRelation
	isSet bool
}

func (v NullableContactExcludeRelation) Get() *ContactExcludeRelation {
	return v.value
}

func (v *NullableContactExcludeRelation) Set(val *ContactExcludeRelation) {
	v.value = val
	v.isSet = true
}

func (v NullableContactExcludeRelation) IsSet() bool {
	return v.isSet
}

func (v *NullableContactExcludeRelation) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableContactExcludeRelation(val *ContactExcludeRelation) *NullableContactExcludeRelation {
	return &NullableContactExcludeRelation{value: val, isSet: true}
}

func (v NullableContactExcludeRelation) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableContactExcludeRelation) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

